/*
 * Gtk-IPtables is Copyright (C) 2006  Daniel E. Testa
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <gtk/gtk.h>
#include <string.h>

#include "settcp.h"

void tcp_flags_func();
void tcp_option_func();
void mss_func();
void syn_func();
void button_ok_func();
void button_cancel_func();

void set_tcp_win()
{
  window_st = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(window_st), "Set TCP");
  gtk_window_set_policy(GTK_WINDOW(window_st), FALSE, FALSE, FALSE);
  gtk_signal_connect(GTK_OBJECT(window_st), "delete_event",
		     GTK_SIGNAL_FUNC(gtk_widget_destroy), NULL);
  gtk_widget_set_usize(window_st, 250, 210);

  box_st[0] = gtk_vbox_new(FALSE, 10);
  box_st[1] = gtk_hbox_new(FALSE, 0);
  box_st[2] = gtk_hbox_new(FALSE, 0);
  box_st[3] = gtk_hbox_new(FALSE, 0);
  box_st[4] = gtk_hbox_new(FALSE, 0);
  box_st[5] = gtk_hbox_new(FALSE, 0);

  gtk_container_add(GTK_CONTAINER (window_st), box_st[0]);
  
  gtk_box_pack_start(GTK_BOX (box_st[0]), box_st[1], FALSE, FALSE, 5);
  gtk_box_pack_start(GTK_BOX (box_st[0]), box_st[2], FALSE, FALSE, 5);
  gtk_box_pack_start(GTK_BOX (box_st[0]), box_st[3], FALSE, FALSE, 5);
  gtk_box_pack_start(GTK_BOX (box_st[0]), box_st[4], FALSE, FALSE, 5);
  gtk_box_pack_start(GTK_BOX (box_st[0]), box_st[5], FALSE, FALSE, 5);
  
  tcp_flags_func();
  tcp_option_func();
  mss_func();
  syn_func();
  button_cancel_func();
  button_ok_func();

  if (state_settcp_f == 1)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check_button_st[0]),
				 TRUE);
  else if (state_settcp_o == 1)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check_button_st[0]),
				 TRUE);
  else if (state_settcp_m == 1)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check_button_st[0]),
				 TRUE);
  else if (state_settcp_s == 1)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check_button_st[0]),
				 TRUE);
  
  
  gtk_widget_show(box_st[1]);
  gtk_widget_show(box_st[2]);
  gtk_widget_show(box_st[3]);
  gtk_widget_show(box_st[4]);
  gtk_widget_show(box_st[5]);
  gtk_widget_show(box_st[0]);
  gtk_widget_show(window_st);
}

void tcp_flags_func()
{
  check_button_st[0] = gtk_check_button_new_with_label("TCP Flags");
  gtk_box_pack_start(GTK_BOX (box_st[1]), check_button_st[0], FALSE, FALSE, 5);
  gtk_widget_show(check_button_st[0]);

  entry_st[0] = gtk_entry_new();
  gtk_widget_set_usize(entry_st[0], 70, 0);
  gtk_signal_connect(GTK_OBJECT(entry_st[0]), "changed",
		     GTK_SIGNAL_FUNC(tcp_flags_a_callback), entry_st[0]);
  gtk_box_pack_start(GTK_BOX (box_st[1]), entry_st[0], FALSE, FALSE, 3);
  gtk_widget_show(entry_st[0]);

  entry_st[1] = gtk_entry_new();
  gtk_widget_set_usize(entry_st[1], 70, 0);
  gtk_signal_connect(GTK_OBJECT(entry_st[1]), "changed",
		     GTK_SIGNAL_FUNC(tcp_flags_b_callback), entry_st[1]);
  gtk_box_pack_start(GTK_BOX (box_st[1]), entry_st[1], FALSE, FALSE, 3);
  gtk_widget_show(entry_st[1]);
}

void tcp_option_func()
{
  check_button_st[1] = gtk_check_button_new_with_label("TCP Option");
  gtk_box_pack_start(GTK_BOX (box_st[2]), check_button_st[1], FALSE, FALSE, 5);
  gtk_widget_show(check_button_st[1]);

  entry_st[2] = gtk_entry_new();
  gtk_widget_set_usize(entry_st[2], 142, 0);
  gtk_signal_connect(GTK_OBJECT(entry_st[2]), "changed",
		     GTK_SIGNAL_FUNC(tcp_option_callback), entry_st[2]);
  gtk_box_pack_start(GTK_BOX (box_st[2]), entry_st[2], FALSE, FALSE, 0);
  gtk_widget_show(entry_st[2]);
}

void mss_func()
{
  check_button_st[2] = gtk_check_button_new_with_label("TCP Mss");
  gtk_box_pack_start(GTK_BOX (box_st[3]), check_button_st[2], FALSE, FALSE, 5);
  gtk_widget_show(check_button_st[2]);

  entry_st[3] = gtk_entry_new();
  gtk_widget_set_usize(entry_st[3], 142, 0);
  gtk_signal_connect(GTK_OBJECT(entry_st[3]), "changed",
		     GTK_SIGNAL_FUNC(tcp_mss_callback), entry_st[3]);
  gtk_box_pack_start(GTK_BOX (box_st[3]), entry_st[3], FALSE, FALSE, 11);
  gtk_widget_show(entry_st[3]);
}

void syn_func()
{
  check_button_st[3] = gtk_check_button_new_with_label("TCP SYN");
  gtk_box_pack_start(GTK_BOX (box_st[4]), check_button_st[3], FALSE, FALSE, 5);
  gtk_widget_show(check_button_st[3]);
}

void button_ok_func()
{
  button_st[0] = gtk_button_new_with_label(" Accept ");
  gtk_signal_connect(GTK_OBJECT(button_st[0]), "clicked",
		     GTK_SIGNAL_FUNC(make_command_line_st), NULL);
  gtk_signal_connect_object(GTK_OBJECT (button_st[0]), "clicked",
			    GTK_SIGNAL_FUNC (gtk_widget_destroy), 
			    GTK_OBJECT (window_st));
  gtk_box_pack_end(GTK_BOX (box_st[5]), button_st[0], FALSE, FALSE, 10);
  gtk_widget_show(button_st[0]);
}

void button_cancel_func()
{
  button_st[1] = gtk_button_new_with_label(" Cancel ");
  gtk_signal_connect_object(GTK_OBJECT (button_st[1]), "clicked",
			    GTK_SIGNAL_FUNC (gtk_widget_destroy), 
			    GTK_OBJECT (window_st));
  gtk_box_pack_end(GTK_BOX (box_st[5]), button_st[1], FALSE, FALSE, 10);
  gtk_widget_show(button_st[1]);
}

